# class Crystal::Macros::CStructOrUnionDef

- Crystal::Macros::CStructOrUnionDef
- Crystal::Macros::ASTNode

##
Overview

A struct or union definition inside a lib.

Every type definition `node` is equivalent to:

    {% begin %}
      {{ node.kind }} {{ node.name }}
        {{ node.body }}
      end
    {% end %}

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #body : ASTNode

  Returns the body of this type definition.

- #kind : MacroId

  Returns the keyword used to define this type.

- #name(*, generic_args : BoolLiteral = true) : Path

  Returns the name of this type definition.

- #union? : BoolLiteral

  Returns whether this node defines a C union.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def body : ASTNode #

Returns the body of this type definition.

def kind : MacroId #

Returns the keyword used to define this type.

For `CStructOrUnionDef` this is either `struct` or `union`.

def name(*, generic_args : BoolLiteral = true) : Path #

Returns the name of this type definition.

generic_args has no effect. It exists solely to match the interface of other related AST nodes.

def union? : BoolLiteral #

Returns whether this node defines a C union.